
; MasterMind 83
; v1.01 * 12/99
; **************
; Kaid
; kaid@excite.fr


#DEFINE TITRE "MasterMind 83"
.INCLUDE ZSHELL83.INC

#DEFINE NUMCOUP     saferam3            ;Numro du coup
#DEFINE COMBI_J     saferam3+1          ;Combinaison du joueur
#DEFINE COMBI_TI    saferam3+5          ;Combinaison de la Ti
#DEFINE COMBI_J2    saferam3+9          ;Combinaison temporaire du joueur
#DEFINE COMBI_TI2   saferam3+13         ;Combinaison temporaire de la Ti
#DEFINE CHXACTU     saferam3+17         ;Position du pion choisie
#DEFINE NBMALPLACES saferam3+18         ;Nombre de pions mal placs
#DEFINE VICTOIRE    saferam3+19         ;Permet de savoir s'il y a victoire


        CALL InitEcran                  ;Initialise l'cran

        LD A,1                          ;
        LD (NUMCOUP),A                  ;Initialise le nombre de coups
        LD (VICTOIRE),A                 ;Et le boolen de victoire



; * Gnre la combinaison  trouver *

        LD D,4                          ;Nombre de pions
        LD HL,COMBI_TI

GenereCombi:
        LD B,5
        CALL ionRandom                  ;Nombre alatoire
        INC A
        LD (HL),A
        INC HL
             
        DEC D                           ; 
        JR NZ,GenereCombi               ;Loop
        


; * Boucle principale *
Boucle:

        CALL InitCoup                   ;Init pour un nouveau coup
        

BoucleChoix:

        CALL AttendTouche               ;Attend la pression d'une touche

        CP G_MODE                       ;
        JR Z,GameOver                   ;Arret du jeu

        CP G_RIGHT                      ;
        CALL Z,ChoixVersDroite          ;Choix  droite 

        CP G_LEFT                       ;
        CALL Z,ChoixVersGauche          ;Choix  gauche

        CP G_UP                         ;
        CALL Z,ChangePionHaut           ;Change pion haut

        CP G_DOWN                       ;
        CALL Z,ChangePionBas            ;Change pion bas 

        CP G_ENTER                      ;
        JR NZ,BoucleChoix               ;Pas de validation


; * Valide la combinaison *

        LD DE,COMBI_J                   ;
        CALL CoordCombi                 ;
        CALL Aff_Combi                  ;Valide la combinaison

        CALL GestionScore               ;Gre le jeu

        OR A                            ;
        JR Z,GameOver                   ;Si A=0, victoire !


; Efface  l'cran la combinaison provisoire
        LD HL,graph_mem+648    
        LD DE,graph_mem+649    
        LD BC,120-1            
        LD (HL),0
        LDIR

        LD A,(NUMCOUP)                  ;
        INC A                           ;
        LD (NUMCOUP),A                  ;Incrmente le nombre de coups

        CP 11                           ;Tant qu'il est diffrent de 11, on
        JR NZ,Boucle                    ;peut encore jouer

; * Game Over *
GameOver:

        CALL InitEcran                  ;Initialise l'cran

        LD DE,COMBI_TI                  ;        
        LD H,$20 \ LD L,$10             ;
        CALL Aff_Combi                  ;Affiche la bonne combinaison

        bcall(_copygbuf)                ;Copie le buffer  l'cran

        LD HL,Str_Lose                  ;Par dfaut, "You lose"

        LD A,(VICTOIRE)                 ;
        OR A                            ;
        JR NZ,PasVictoire               ;On teste s'il y a victoire

; Victoire
        LD HL,$0705                     
        LD (CURSOR_ROW),HL              
        LD A,(NUMCOUP)                  ;
        LD L,A \ LD H,0                 ;HL=A=Nombre de coups
        bcall(_disphl)                  ;Affiche le nombre d'essais

        LD HL,$0305                     ;
        LD (CURSOR_ROW),HL              ;
        LD HL,Str_Nb                    ;
        bcall(D_ZT_STR)                 ;Affiche "Tries:"

        LD HL,Str_Win                   ;"You win"

; Dfaite
PasVictoire:
        LD DE,$0404                     ;
        LD (CURSOR_ROW),DE              ;
        bcall(D_ZT_STR)                 ;Affiche "You lose" ou "You win"

        LD HL,$3918                     ;
        LD (CURSOR_X),HL                ;
        LD HL,Str_Who                   ;
        bcall(D_ZM_STR)                 ;Affiche l'e-mail

        CALL AttendTouche               ;Attend la pression d'une touche

        RET                             ;Retourne au shell


; * Gestion du score *
GestionScore:

; On place les combinaisons dans des variables temporaires

        LD HL,COMBI_J                   ;
        LD DE,COMBI_J2                  ;
        LD BC,8                         ;
        LDIR                            ;Copie les deux combinaisons

        CALL Nb_BienPlaces              ;Calcul le nombre de pions bien placs

        PUSH AF                         ;Sauve le rsultat
        LD B,35                         ;Position Y
        CALL Aff_Nb                     ;Affiche le nombre correspondant
        POP AF

        CP 4                            ;
        JR Z,Victoire                   ;S'il est gal  4, c'est gagn


        CALL Nb_MalPlaces               ;Calcul de nombre de pions mals placs

        LD B,41                         ;Position Y
        CALL Aff_Nb                     ;Affiche le nombre correspondant

        LD A,1                          ;Code de retour
        RET

Victoire:
        XOR A                           ;Code de retour
        LD (VICTOIRE),A
        RET



; * Affiche le chiffre dans A  la position Y=<B> *
Aff_Nb:
        PUSH AF                         ;Sauve le rsultat
        CALL CoordCombi                 ;Calcul des coordones

        LD A,H                          ;
        LD H,L                          ;
        INC H                           ;
        ADD A,B                         ;
        LD L,A                          ;
        LD (CURSOR_X),HL                ;Position pour l'affichage

        POP AF
        SET 7,(IY+$14)                  ;Pour crire dans la mmoire vido
        ADD A,$30                       ;A=Code ASCII du chiffre  afficher
        bcall(M_CHARPUT)                ;On l'affiche        
        RES 7,(IY+$14)                  
        RET        


; * Choix vers la droite *
ChoixVersDroite:

        CALL AffChoix                   ;Efface le prcdent choix

        LD A,(CHXACTU)
        INC A                           ;A=Choix dsir

        CP 4                            ;
        JR NZ,PasDeRetourGauche         ;

        XOR A                           ;Retour  gauche

PasDeRetourGauche:

        JR Choix_Valide                 ;Valide le choix


; * Choix vers la gauche *
ChoixVersGauche:

        CALL AffChoix                   ;Efface le prcdent choix

        LD A,(CHXACTU)

        OR A                            ;On teste pour savoir s'il ne doit        
        JR NZ,PasDeRetourDroite         ; pas aller au dernier pion

        LD A,4                          ;Retour  droite (aprs DEC A)

PasDeRetourDroite:
        DEC A                           

Choix_Valide:
        LD (CHXACTU),A                  ;On sauve le nouveau choix

        CALL AffChoix                   ;Et on l'affiche
        bcall(_copygbuf)

        RET


; * Change le pion (haut) *
ChangePionHaut:

        CALL Aff_PionChoix              ;Efface le pion actuel
        LD A,(HL)                       ;A contient le pion

        CP 5                            ;On teste pour savoir s'il ne doit        
        JR NZ,PasPremierPion            ; pas aller au premier pion

        XOR A                           ;Retour au premier pion (aprs INC A)

PasPremierPion:

        INC A                           ;Prochain pion
        JR Pion_Valide                  ;Valide le pion


; * Change le pion (bas) *
ChangePionBaS:

        CALL Aff_PionChoix              ;Efface le pion actuel
        LD A,(HL)                       ;A contient le pion

        DEC A                           ;Pion prcdent

        OR A                            
        JR NZ,Pion_Valide

        LD A,5                          ;Prend le dernier pion

Pion_Valide:

        LD (HL),A                       ;Place le nouveau pion

        CALL Aff_PionChoix              ;Et l'affiche
        bcall(_copygbuf)
        RET


; * Attend la pression d'une touche *
AttendTouche:

        bcall(GET_KEY)

        OR A
        JR Z,AttendTouche        

        RET


; * Affiche le choix (soulign)
AffChoix:
        LD A,(CHXACTU)
        CALL MulA_8                     ;Multiplie A par 8
        ADD A,$20

        LD L,$36+8
        LD IX,Img+4                     ;Juste pour avoir un %11111111
        LD B,1
        CALL ionPutSprite
        RET


;* Affiche une combinaison pointe par DE *
Aff_Combi:
        XOR A

Aff_Combi_Boucle:

        PUSH AF

        CALL MulA_8                     ;Multiplie A par 8

        ADD A,H

        CALL Aff_Pion
        POP AF

        INC A
        INC DE
        CP 4
        JR NZ,Aff_Combi_Boucle
        RET


; * Retourne les coordonnes d'une combinaison en fonction du nombre de coups *
CoordCombi:

        LD A,(NUMCOUP)
        LD H,0

        CP 6
        JR C,PasSurSecondePartie

        SUB 5
        LD H,6*8+2

PasSurSecondePartie:

        CALL MulA_8                     ;Multiplie A par 8

        LD L,A

        RET

; * Affiche un pion *
Aff_Pion:
        LD B,A
        LD A,(DE)
        DEC A
        CALL MulA_8                     ;Multiplie A par 8

        PUSH DE
        
        LD E,A \ LD D,0

        LD IX,Spr1
        ADD IX,DE

        LD A,B
        LD B,7

        PUSH HL
        call ionPutSprite
        POP HL
        POP DE
        RET


; * Affiche le pion choisie *
Aff_PionChoix:
        LD A,(CHXACTU)
        LD E,A \ LD D,0
        LD HL,COMBI_J
        ADD HL,DE                       ;HL pointe sur le pion dans la combi
        PUSH HL
        EX DE,HL

        CALL MulA_8                     ;Multiplie A par 8

        ADD A,$20
        LD L,$36
        CALL Aff_Pion

        POP HL
        RET

; * Initialisation avant un nouveau coup *
InitCoup:
        LD A,1
        LD HL,COMBI_J

        LD B,4                          ;
                                        ;
GenCombi:                               ;
        LD (HL),A                       ;
        INC HL                          ;
        DJNZ GenCombi                   ;Gnre une combinaison 1-1-1-1


        LD DE,COMBI_J                   ;
        LD HL,$2036                     ;
        CALL Aff_Combi                  ;Affiche la combinaison

        XOR A                           ;
        LD (CHXACTU),A                  ;Choix du premier pion

        CALL AffChoix
        bcall(_copygbuf)
        RET


; * Retourne le nombre de pions bien placs *
Nb_BienPlaces:

        LD C,0                          ;Compteur

        LD DE,COMBI_J2                  ;Combinaison du joueur
        LD HL,COMBI_TI2                 ;Combinaison de la Ti

        LD B,4                          ;Nombre de pions

Nb_BienPlaces_B:

        LD A,(DE)

        CP (HL)
        JR NZ,PasBienPlace

        XOR A                           ;
        LD (DE),A                       ;
        LD (HL),A                       ;Efface le pion dans les combinaisons

        INC C                           ;Incrmente le compteur

PasBienPlace:

        INC DE                          ;
        INC HL                          ;Prochains pions

        DJNZ Nb_BienPlaces_B

        LD A,C                          ;A=Nombre
        RET


; * Retourne le nombre de pions mal placs *
Nb_MalPlaces:

        XOR A                           ;
        LD (NBMALPLACES),A              ;Compteur

        LD DE,COMBI_J2                  ;Combinaison du joueur

        LD B,4

ParcoursPionJoueur:
        LD A,(DE)                       ;A=Pion du joueur

        OR A                            ;
        JR Z,CePionAEteTrouve           ;Si A=0, le joueur a trouv le pion

        PUSH BC

        LD C,A                          ;C=Pion du joueur
        LD B,4
        LD HL,COMBI_TI2                 ;Combinaison de la Ti

ParcoursPionTi:
        LD A,(HL)

        OR A                            ;
        JR Z,AutrePion                  ;Ce pion a dj t trouv

        CP C                            ;
        JR NZ,AutrePion                 ;Si C!=A, on cherche un autre pion

        XOR A                           ;
        LD (HL),A                       ;Efface le pion dans la combinaison Ti

        LD HL,NBMALPLACES               ;
        INC (HL)                        ;Incrmente le nombre

        JR ParcoursPionTi_F             ;Fin du parcours


AutrePion:

        INC HL

        DJNZ ParcoursPionTi


ParcoursPionTi_F:
        POP BC
                

CePionAEteTrouve:

        INC DE

        DJNZ ParcoursPionJoueur

        LD A,(NBMALPLACES)
        RET


; * Init l'cran (efface+aff titre) *
InitEcran:
        bcall(_cleargbuf)               ;Efface le buffer graphique

        LD DE,graph_mem                 ;
        LD HL,Img                       ;
        LD BC,12*8                      ;
        LDIR                            ;Affiche le titre
        RET


; * Multiplie A par 8 *
MulA_8:
        SLA A \ SLA A \ SLA A           ;A*=8
        RET

; * Multiplie A par 5 *
MulA_5:
        LD B,A
        SLA A \ SLA A                   ;A*=4
        ADD A,B                         ;A+=A
        RET

; * Chaines *
Str_Lose        .DB "You lose",0
Str_Win         .DB "You win",0
Str_Who         .DB "kaid@excite.fr",0
Str_Nb          .DB "Tries:",0

; * Sprites *
.INCLUDE SPRITES.INC

.END

